import 'package:cl_appbase/api.dart';
import 'package:cl_appbase/appbase.dart';

import '../api.dart';
import '../api_resource.dart';

class ListHubResource<TData extends TransferObject, TId>
    extends ListApiResource<TData, TId> implements Collection {
  ListHubResource(ApiBase api, String endpointSuffix, factory)
      : super(api, endpointSuffix, factory);

  Future<TData> getMetaData<TData>(String key) async {
    final response = await request<Map<String, dynamic>, Map<String, dynamic>>(
        api.baseUrl, '$endpointSuffix/\$$key', null, ApiRequestMethod.GET,
        headers: api.getRequestHeaders());
    response.throwOnError();
    return response.data[key] as TData;
  }

  /// Implements Collection.getItems
  @override
  Future<List<TData>> getItems(int offset, int limit) async =>
      await getList(offset, limit);

  /// Implements Collection.getSize
  @override
  Future<int> getSize() async => await getMetaData('count');
}

class SingleObjectHubResource extends SingleObjectApiResource {
  SingleObjectHubResource(ApiBase api, String endpointSuffix, factory)
      : super(api, endpointSuffix, factory);

  Future<TData> getMetaData<TData>(String key) async {
    final response = await request<Map<String, dynamic>, Map<String, dynamic>>(
        api.baseUrl, '$endpointSuffix/\$$key', null, ApiRequestMethod.GET,
        headers: api.getRequestHeaders());
    response.throwOnError();
    return response.data[key] as TData;
  }
}
